/**********************************************************************
 * Copyright (c) 2004 Hyades project.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
/**
 * @author slavescu
 */
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
public class DownloadAndExtractZIP {
	public static byte[] buffer = new byte[2 * 1024 * 1024];
	public static final void copyInputStream(InputStream in, OutputStream out) throws IOException {
		int len;
		while ((len = in.read(buffer)) >= 0)
			out.write(buffer, 0, len);
		out.close();
	}
	public static final void main(String[] args) {
		if (args.length != 3) {
			System.err.println("Usage: DownloadAndExtractZIP targetDir zipfileURL startEntry");
			return;
		}
		try {
			String prefixDir = args[0];
			String startEntry = args[2];
			boolean start = false;
			if (startEntry.equals("\\")) {
				start = true;
			}
			URLConnection connection = (new URL(args[1])).openConnection();
			InputStream inputStream = connection.getInputStream();
			ZipInputStream zipInputStream = new ZipInputStream(inputStream);
			String fileName;
			File file, parent;
			while (zipInputStream.available() > -1) {
				ZipEntry entry = (ZipEntry) zipInputStream.getNextEntry();
				if (entry == null) {
					System.out.println("End of zip file !");
					break;
				}
				fileName = entry.getName();
				if (!start && fileName.equals(startEntry)) {
					start = true;
					System.out.println("Start extracting: " + fileName);
				}
				if (start) {
					file = (new File(prefixDir + fileName));
					if (entry.isDirectory()) {
						file.mkdir();
						continue;
					}
					parent = file.getParentFile();
					if (parent != null && !parent.exists())
						parent.mkdirs();
					copyInputStream(zipInputStream, new BufferedOutputStream(new FileOutputStream(file)));
				}
				zipInputStream.closeEntry();
			}
			zipInputStream.close();
			inputStream.close();
		} catch (Exception ioe) {
			ioe.printStackTrace();
			return;
		}
	}
}