/**********************************************************************
 * Copyright (c) 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id$
 **********************************************************************/
package org.eclipse.cosmos.dr.reports.oda;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.tptp.platform.provisional.dms.DataAccessFactory;
import org.eclipse.tptp.platform.provisional.dms.IDataContext;
import org.eclipse.tptp.platform.provisional.dms.IDataOutputFormat;
import org.eclipse.tptp.platform.provisional.dms.IDataProperty;
import org.eclipse.tptp.platform.provisional.dms.IDataSource;
import org.eclipse.tptp.platform.provisional.dms.log.ILogDataService;
import org.eclipse.tptp.platform.provisional.dms.log.ILogRecord;

/**
 * An data accessor class that is used to retrieve the log records from
 * monitoring session
 * 
 * @author slavescu
 * 
 */

public class LogDataAccessor {
	public static String LOG_ID = "//" + ILogDataService.id
			+ ":log[@id=\"78\"]";
	public static String JDBCDriverLocation = "file:/c:/COSMOS-Demo-EclipseCon2007/derby/db-derby-10.2.2.0-bin/lib/derbyclient.jar";
	public static String location = "127.0.0.1";
	public static String user = "APP";
	public static String password = "APP";

	public List getLogRecords(IDataSource dataSource,
			IDataOutputFormat dataOutputFormat) {

		if (dataSource == null)
			dataSource = DataAccessFactory.getResourceDataService()
					.createDataSource("log:"); // empty data source

		if (dataOutputFormat == null) {
			dataOutputFormat = (ILogRecord) DataAccessFactory
					.getLogDataService().createDataOutputFormat(
							ILogRecord.class);
			IDataProperty dataProperty = DataAccessFactory.getLogDataService()
					.createDataProperty("@msg", "string", null);
			dataOutputFormat.getDynamicProperties().add(dataProperty);
			dataProperty = DataAccessFactory.getLogDataService()
					.createDataProperty("@creationTime", "string", null);
			dataOutputFormat.getDynamicProperties().add(dataProperty);
			dataProperty = DataAccessFactory.getLogDataService()
					.createDataProperty("@extensionName", "string", null);
			dataOutputFormat.getDynamicProperties().add(dataProperty);
			dataProperty = DataAccessFactory.getLogDataService()
					.createDataProperty("@severity", "string", null);
			dataOutputFormat.getDynamicProperties().add(dataProperty);
			dataProperty = DataAccessFactory.getLogDataService()
					.createDataProperty("@location", "string", null);
			dataOutputFormat.getDynamicProperties().add(dataProperty);
			dataProperty = DataAccessFactory.getLogDataService()
					.createDataProperty("@subComponent", "string", null);
			dataOutputFormat.getDynamicProperties().add(dataProperty);

			if (dataOutputFormat.getDataContext() == null) {
				dataOutputFormat
						.setDataContext(DataAccessFactory.getLogDataService()
								.createDataContext(
										"//" + ILogDataService.id
												+ ":log[@id=\"78\"]"));
			}
		}

		return (List) (DataAccessFactory.getDataAccessController()
				.executeCommand(
						null,
						DataAccessFactory.getLogDataService().getLogRecords(
								dataSource, dataOutputFormat, null, null),
						true, null).getResult());
	}

	public List getSeverityList(IDataSource dataSource,
			IDataOutputFormat dataOutputFormat) {
		List res=new ArrayList();
		List logRecords = getLogRecords(null, null);
		for (int i = 0; i < logRecords.size(); i++) {
			
		}
		return res;
	}

	public List getRefs(IDataSource dataSource,
			IDataOutputFormat dataOutputFormat) {
		return (List) (DataAccessFactory.getDataAccessController()
				.executeCommand(
						null,
						DataAccessFactory.getLogDataService().getRefs(
								dataSource, dataOutputFormat), true, null)
				.getResult());
	}

	private void testGetLogRecords() {

		List logRecords = getLogRecords(null, null);
		for (int count = 0; count < logRecords.size(); count++) {
			ILogRecord logRecord = (ILogRecord) logRecords.get(count);
			IDataProperty nameProp = ((IDataProperty) (logRecord)
					.getDynamicProperties().get(0));
			System.out.println(nameProp.getName() + "[" + count + "]="
					+ nameProp.getValue());
			IDataProperty descriptionProp = ((IDataProperty) logRecord
					.getDynamicProperties().get(1));
			System.out.println(descriptionProp.getName() + "=[" + count + "]"
					+ descriptionProp.getValue());
			System.out.println("contextURI[" + count + "]="
					+ logRecord.getDataContext().getURI());
		}
	}

	public static void main(String[] args) {
		LogDataAccessor logDataAccessor = new LogDataAccessor();
		logDataAccessor.testGetLogRecords();
	}

	public static IDataContext createDataContext(String uri) {
		return DataAccessFactory.getLogDataService().createDataContext(uri);
	}

	public static IDataProperty createDataProperty(String name, String type,
			String value) {
		return DataAccessFactory.getLogDataService().createDataProperty(name,
				type, value);
	}

	public static ILogRecord createILogRecord(String uri) {

		ILogRecord res = (ILogRecord) DataAccessFactory.getLogDataService()
				.createDataOutputFormat(ILogRecord.class);
		res.setDataContext(DataAccessFactory.getLogDataService()
				.createDataContext(uri));
		return res;
	}

}
